Package org.zkoss.zk.ui

## Enum HtmlShadowElement.Direction

- java.lang.Object
- - java.lang.Enum<HtmlShadowElement.Direction>
  - - org.zkoss.zk.ui.HtmlShadowElement.Direction

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<HtmlShadowElement.Direction>`
  Enclosing class:
    HtmlShadowElement

      public static enum HtmlShadowElement.Direction
      extends java.lang.Enum<HtmlShadowElement.Direction>

  A help class for an insertion direction.
  Author:
    jumperchen

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `AFTER_NEXT` | It indicates the direction of the target is inserted after the next insertion
    `BEFORE_PREVIOUS` | It indicates the direction of the target is inserted before the previous insertion
    `FIRST` | It indicates the direction of the target is the same as the first insertion
    `IN_RANGE` | It indicates the direction of the target is inserted in its descendant insertion range
    `LAST` | It indicates the direction of the target is the same as the last insertion
    `NEXT` | It indicates the direction of the target is the same as the next insertion
    `PREVIOUS` | It indicates the direction of the target is the same as the previous insertion
    `UNKNOWN` | It cannot indicate the direction of the target where it should be inserted.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static HtmlShadowElement.Direction` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static HtmlShadowElement.Direction[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### BEFORE_PREVIOUS

          public static final HtmlShadowElement.Direction BEFORE_PREVIOUS

      It indicates the direction of the target is inserted before the previous insertion

    - #### PREVIOUS

          public static final HtmlShadowElement.Direction PREVIOUS

      It indicates the direction of the target is the same as the previous insertion

    - #### FIRST

          public static final HtmlShadowElement.Direction FIRST

      It indicates the direction of the target is the same as the first insertion

    - #### IN_RANGE

          public static final HtmlShadowElement.Direction IN_RANGE

      It indicates the direction of the target is inserted in its descendant insertion range

    - #### LAST

          public static final HtmlShadowElement.Direction LAST

      It indicates the direction of the target is the same as the last insertion

    - #### NEXT

          public static final HtmlShadowElement.Direction NEXT

      It indicates the direction of the target is the same as the next insertion

    - #### AFTER_NEXT

          public static final HtmlShadowElement.Direction AFTER_NEXT

      It indicates the direction of the target is inserted after the next insertion

    - #### UNKNOWN

          public static final HtmlShadowElement.Direction UNKNOWN

      It cannot indicate the direction of the target where it should be inserted.

  - ### Method Detail

    - #### values

          public static HtmlShadowElement.Direction[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (HtmlShadowElement.Direction c : HtmlShadowElement.Direction.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static HtmlShadowElement.Direction valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null